<?php

	// Load gateway settings
	require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/idealcheckout/includes/library.php');
	
	class idealcheckoutvisa extends base 
	{
		var $code;
		var $title;
		var $description;
		var $enabled;
		var $payment;

		function idealcheckoutvisa()
		{
			global $order;

			$aGatewaySettings = idealcheckout_getGatewaySettings(false, 'visa');

			$sHtml = '
<p>Via deze plugin kunt u Visa betalingen ontvangen in uw webshop via diverse Payment Service Providers.</p>
<p>Deze plugin is momenteel geconfigureerd om Visa transacties te verwerken via <b>' . htmlspecialchars($aGatewaySettings['GATEWAY_NAME']) . '</b>.<br>Meer informatie over deze Payment Service Provider vind u op <a href="' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '" target="_blank">' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '</a></p>';

			if($aGatewaySettings['GATEWAY_VALIDATION'])
			{
				$sHtml .= '
<p>&nbsp;</p>
<h2>Transacties Controleren</h2>
<p>Controleer de status van alle openstaande transacties bij uw Payment Service Provider.</p>
<p><input type="button" value="Controleer openstaande transacties." onclick="javascript: window.open(\'' . idealcheckout_getRootUrl(1) . 'idealcheckout/validate.php?gateway=visa\', \'popup\', \'directories=no,height=550,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,width=750\');"></p>';
			}

			$sHtml .= '
<p>&nbsp;</p>
<h2>Over deze plugin</h2>
<p>Deze Visa plugin is ontwikkeld door <a href="https://www.ideal-checkout.nl" target="_blank">iDEAL Checkout</a> en is GRATIS te downloaden via <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a>.<br><br>- Voor vragen over deze plugin kunt u kijken op <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a> of mailen naar <a href="mailto:info@ideal-checkout.nl">info@ideal-checkout.nl</a><br>- Feedback en donaties<br>- Het gebruik van onze plugins/scripts is geheel op eigen risico.</p>';
				

			$this->code = 'idealcheckoutvisa';
			$this->title = 'iDEAL Checkout - Visa';
			$this->description = $sHtml;
			$this->payment = 'Visa';
			$this->enabled = ((MODULE_PAYMENT_IDEALCHECKOUTVISA_STATUS == 'True') ? true : false);
			$this->sort_order = MODULE_PAYMENT_IDEALCHECKOUTVISA_SORT_ORDER;
		}

		function update_status()
		{
			return true;
		}

		function javascript_validation()
		{
			return false;
		}

		function selection() 
		{
			return array('id' => $this->code, 'module' => $this->title);
		}

		function pre_confirmation_check() 
		{
			return false;
		}

		function confirmation() 
		{
			return array('title' => $this->title);
		}

		function process_button() 
		{
			return false;
		}

		function before_process() 
		{
			return false;
		}

		function after_process() 
		{
			global $db, $order;

			if(isset($order->info['payment_module_code']) && (strcasecmp($order->info['payment_module_code'], 'idealcheckoutvisa') === 0))
			{
				$aDatabaseSettings = idealcheckout_getDatabaseSettings();

				$sStoreCode = idealcheckout_getStoreCode();
				$sGatewayCode = 'visa';
				$sLanguageCode = 'nl'; // nl, de, en
				$sCountryCode = '';
				$sCurrencyCode = 'EUR';

				$sOrderId = $_SESSION['order_summary']['order_number'];
				$sOrderCode = idealcheckout_getRandomCode(32);
				$aOrderParams = array();
				$sTransactionId = idealcheckout_getRandomCode(32);
				$sTransactionCode = idealcheckout_getRandomCode(32);
				$fTransactionAmount = round($_SESSION['order_summary']['order_total'], 2);
				$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
				$sTransactionPaymentUrl = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');
				$sTransactionSuccessUrl = zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL');

				$sTransactionSuccessUrl .= (strpos($sTransactionSuccessUrl, '?') ? '&' : '?') . 'action=empty_cart';
				$sTransactionPendingUrl = $sTransactionSuccessUrl;
				$sTransactionFailureUrl = $sTransactionPaymentUrl;





				$aOrderParams['customer'] = array();

				// Shipment data
				list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($order->delivery['street_address']);

				$aOrderParams['customer']['shipment_company'] = $order->delivery['company'];
				$aOrderParams['customer']['shipment_name'] = $order->delivery['firstname'] . ' ' . $order->delivery['lastname'];
				$aOrderParams['customer']['shipment_first_name'] = $order->delivery['firstname'];
				$aOrderParams['customer']['shipment_last_name'] = $order->delivery['lastname'];
				$aOrderParams['customer']['shipment_gender'] = '';
				$aOrderParams['customer']['shipment_date_of_birth'] = '';
				$aOrderParams['customer']['shipment_phone'] = $order->customer['telephone'];
				$aOrderParams['customer']['shipment_email'] = $order->customer['email_address'];
				$aOrderParams['customer']['shipment_address'] = $order->delivery['street_address'];
				$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
				$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
				$aOrderParams['customer']['shipment_street_number_extension'] = $sExtension;
				$aOrderParams['customer']['shipment_zipcode'] = $order->delivery['postcode'];
				$aOrderParams['customer']['shipment_city'] = $order->delivery['city'];
				$aOrderParams['customer']['shipment_country_code'] = $order->delivery['country']['iso_code_2'];
				$aOrderParams['customer']['shipment_country_name'] = ((strcasecmp($order->delivery['country']['iso_code_2'], 'BE') === 0) ? 'Belgie' : 'Nederland');


				// Payment data
				list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($order->billing['street_address']);

				$aOrderParams['customer']['payment_company'] = $order->billing['company'];
				$aOrderParams['customer']['payment_name'] = $order->billing['firstname'] . ' ' . $order->billing['lastname'];
				$aOrderParams['customer']['payment_first_name'] = $order->billing['firstname'];
				$aOrderParams['customer']['payment_last_name'] = $order->billing['lastname'];
				$aOrderParams['customer']['payment_gender'] = '';
				$aOrderParams['customer']['payment_date_of_birth'] = '';
				$aOrderParams['customer']['payment_phone'] = $order->customer['telephone'];
				$aOrderParams['customer']['payment_email'] = $order->customer['email_address'];
				$aOrderParams['customer']['payment_address'] = $order->billing['street_address'];
				$aOrderParams['customer']['payment_street_name'] = $sStreetName;
				$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
				$aOrderParams['customer']['payment_street_number_extension'] = $sExtension;
				$aOrderParams['customer']['payment_zipcode'] = $order->billing['postcode'];
				$aOrderParams['customer']['payment_city'] = $order->billing['city'];
				$aOrderParams['customer']['payment_country_code'] = $order->billing['country']['iso_code_2'];
				$aOrderParams['customer']['payment_country_name'] = ((strcasecmp($order->billing['country']['iso_code_2'], 'BE') === 0) ? 'Belgie' : 'Nederland');


				// Products
				$aOrderParams['products'] = array();

				$fTotalAmountIncl = 0.00;
				$fTotalAmountExcl = 0.00;

				foreach($order->products as $k => $aProduct)
				{
					$fPriceExcl = round($aProduct['final_price'], 2);
					$fPriceVat = round($fPriceExcl * ($aProduct['tax'] / 100), 2);
					$fPriceIncl = round($fPriceExcl + $fPriceVat, 2);

					$fVatPercentage = $aProduct['tax'];
					$fQuantity = $aProduct['qty'];

					$fTotalAmountIncl += ($fPriceIncl * $fQuantity);
					$fTotalAmountExcl += ($fPriceExcl * $fQuantity);

					$aOrderParams['products'][] = array('code' => $aProduct['id'], 'description' => $aProduct['name'], 'quantity' => $fQuantity, 'price_incl' => $fPriceIncl, 'price_excl' => $fPriceExcl, 'vat' => $fVatPercentage);
				}



				// Payment costs?
				$fPaymentExcl = round(empty($order->info['payment_cost']) ? 0 : $order->info['payment_cost'], 2);
				$fPaymentTaxPercentage = round(empty($order->info['payment_tax']) ? 0 : $order->info['payment_tax'], 2);
				$fPaymentTax = round($fPaymentExcl * ($fPaymentTaxPercentage / 100), 2);
				$fPaymentIncl = round($fPaymentExcl + $fPaymentTax, 2);

				if(!empty($fPaymentIncl))
				{
					$fTotalAmountIncl += $fPaymentIncl;
					$fTotalAmountExcl += $fPaymentExcl;

					$aOrderParams['products'][] = array('code' => 'PAYMENT', 'description' => 'Betaalkosten', 'quantity' => '1', 'price_incl' => $fPaymentIncl, 'price_excl' => $fPaymentExcl, 'vat' => $fPaymentTaxPercentage);
				}



				// Shipment costs?
				$fShipmentExcl = round(empty($order->info['shipping_cost']) ? 0 : $order->info['shipping_cost'], 2);
				$fShipmentTaxPercentage = round(empty($order->info['shipping_tax']) ? 0 : $order->info['shipping_tax'], 2);
				$fShipmentTax = round($fShipmentExcl * ($fShipmentTaxPercentage / 100), 2);
				$fShipmentIncl = round($fShipmentExcl + $fShipmentTax, 2);

				if(!empty($fShipmentIncl))
				{
					$fTotalAmountIncl += $fShipmentIncl;
					$fTotalAmountExcl += $fShipmentExcl;

					$aOrderParams['products'][] = array('code' => 'SHIPPING', 'description' => 'Verzendkosten', 'quantity' => '1', 'price_incl' => $fShipmentIncl, 'price_excl' => $fShipmentExcl, 'vat' => $fShipmentTaxPercentage);
				}

				$fCorrection = round($fTransactionAmount - $fTotalAmountIncl, 2);

				if($fCorrection != 0.00)
				{
					$aOrderParams['products'][] = array('code' => 'CORRECTION', 'description' => 'Correctie', 'quantity' => '1', 'price_incl' => $fCorrection, 'price_excl' => $fCorrection, 'vat' => 0);
				}

				if($fTransactionAmount < 1.00)
				{
					return '<p>Invalid transaction amount, should be atleast 1 euro.</p>
			
<!-- 
	
		FILE:    ' . __FILE__ . '
		LINE:    ' . __LINE__ . '

		ORDER: ' . json_encode($order) . '
-->';
				}
				else
				{
					// Insert into #_transactions
					$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

					$db->Execute($sql);

					// Redirect
					zen_redirect(idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
				}
			}

			return '<p>Unknown payment request.</p>
			
<!-- 
	
		FILE:    ' . __FILE__ . '
		LINE:    ' . __LINE__ . '

		ORDER: ' . json_encode($order) . '
-->';
		}

		function check_referrer($zf_domain)
		{
			return true;
		}

		function get_error() 
		{
			return false;
		}

		function check() 
		{
			global $db;
			
			if(!isset($this->_check))
			{
				$check_query = $db->Execute("SELECT `configuration_value` FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` = 'MODULE_PAYMENT_IDEALCHECKOUTVISA_STATUS'");
				$this->_check = $check_query->RecordCount();
			}
			
			return $this->_check;
		}

		function install() 
		{
		    $this->notify('To setup this gateway, please use the configuration file.');
		}

		function remove() 
		{
		}

		function keys() 
		{
			return array('MODULE_PAYMENT_IDEALCHECKOUTVISA_STATUS', 'MODULE_PAYMENT_IDEALCHECKOUTVISA_SORT_ORDER');
		}
	}

?>